##
from Components.ActionMap import ActionMap
from Components.MenuList import MenuList
import os
from Plugins.Plugin import PluginDescriptor
from Screens.Console import Console
from Components.Console import Console as Components_Console
from Screens.Screen import Screen
from Tools.Directories import resolveFilename, SCOPE_PLUGINS, fileExists
#from Screens.Standby import TryQuitMainloop

############################################

class ScriptExecuter(Screen):
	skin = """
	<screen position="center,center" size="420,400" title="DuckBA manager" >
		<widget name="list" position="0,0" size="420,400" scrollbarMode="showOnDemand" />
	</screen>"""

	def __init__(self, session, args=None):
		Screen.__init__(self, session)
		self.session = session
		
		try:
			list = os.listdir("/usr/lib/enigma2/python/Plugins/Extensions/DuckBAplugin/scripts/")
			list = [x[:-3] for x in list if x.endswith('.sh')]
		except:
			list = []
		print "DBA LIST"
		print list
		self["list"] = MenuList(list)
		
		self["actions"] = ActionMap(["OkCancelActions"], {"ok": self.run, "cancel": self.close}, -1)

	def run(self):
		script = self["list"].getCurrent()
		if script is not None:
			name = ("/usr/lib/enigma2/python/Plugins/Extensions/DuckBAplugin/scripts/%s.sh" % script)
			os.chmod(name, 0755)
			self.session.open(Console, script.replace("_", " "), cmdlist=[name])

############################################

class RebootMENU(Screen):
	skin = """
	<screen position="center,center" size="320,300" title="DuckBA reboot" >
		<widget name="list" position="0,0" size="420,400" scrollbarMode="showOnDemand" />
	</screen>"""

	def __init__(self, session, args=None):
		Screen.__init__(self, session)
		self.session = session
		BOOTITEM1_SDXY = ""
		BOOTITEM2_SDXY = ""
		BOOTITEM3_SDXY = ""
		#name,kernel nand address, jON (0/1),jDEV
		list = []
		list.append((_("Reboot to ") + "Flash","0",0,""))

		if fileExists("/tmp/bootitems.DBA"):
			f = open('/tmp/bootitems.DBA', 'r')
			try:
				BOOTITEM1 = f.readline().strip('\n') 
				BOOTITEM1_SDXY = BOOTITEM1.split(".", 1)[1]
				print BOOTITEM1
			except:
				BOOTITEM1_SDXY = ""
				print ("Analysing bootitem1 '%s' error" % BOOTITEM1)
			try:
				BOOTITEM2 = f.readline().strip('\n') 
				BOOTITEM2_SDXY = BOOTITEM2.split(".", 1)[1]
				print BOOTITEM2
			except:
				BOOTITEM2_SDXY = ""
				print ("Analysing bootitem1 '%s' error" % BOOTITEM2)
			try:
				BOOTITEM3 = f.readline().strip('\n') 
				BOOTITEM3_SDXY = BOOTITEM3.split(".", 1)[1]
				print BOOTITEM3
			except:
				BOOTITEM3_SDXY = ""
				print ("Analysing bootitem1 '%s' error" % BOOTITEM3)
			f.close()
			if BOOTITEM1_SDXY != "":
				list.append((_("Reboot to ") + BOOTITEM1.replace("."," on "),"401000",1, BOOTITEM1_SDXY))
			if BOOTITEM2_SDXY != "":
				list.append((_("Reboot to ") + BOOTITEM2.replace("."," on "),"6A1000",1, BOOTITEM2_SDXY))
			if BOOTITEM3_SDXY != "":
				list.append((_("Reboot to ") + BOOTITEM3.replace("."," on "),"941000",1, BOOTITEM3_SDXY))

		self["list"] = MenuList(list)
		self["actions"] = ActionMap(["OkCancelActions"], {"ok": self.run, "cancel": self.close}, -1)
			

	def run(self):
		BOOTITEM = self["list"].getCurrent()
		print ("DBA selected image: %s , NAND address: %s , jON: %s, jDEV: %s"  % (BOOTITEM[0],BOOTITEM[1],BOOTITEM[2],BOOTITEM[3]))
		WRITE_DEBUG = ""
		if os.path.exists("/DuckBA"):
			WRITE_DEBUG = ">>/DuckBA/plugin.log 2>&1"
			fw = open('/DuckBA/plugin.log', 'w')
			fw.write("=====================================================================\n")
			fw.write("DBA selected image: %s , NAND address: %s , jON: %s, jDEV: %s \n"  % (BOOTITEM[0],BOOTITEM[1],BOOTITEM[2],BOOTITEM[3]))
			fw.write("=====================================================================\n")
			fw.close
		
		if fileExists("/tmp/fw_setenv"):
			# let's activate DBA
			# for USB images we have to set kernels address in NAND
			#Components_Console().ePopen(("/tmp/fw_setenv jON %s >/DuckBA/plugin.log 2>&1 ; sleep 2" % BOOTITEM[2])) 
			os.system("/tmp/fw_setenv jON %s %s" % (BOOTITEM[2] , WRITE_DEBUG))
			if BOOTITEM[2] == 1:
				#Components_Console().ePopen(("/tmp/fw_setenv jOFST %s >>/DuckBA/plugin.log 2>&1 ; sleep 2" % BOOTITEM[1]))
				os.system("/tmp/fw_setenv jOFST %s %s" % (BOOTITEM[1] , WRITE_DEBUG))
				os.system("/tmp/fw_setenv jDEV %s %s" % (BOOTITEM[3] , WRITE_DEBUG))
				
			from enigma import quitMainloop
			quitMainloop(2)
			

############################################

def main(session, **kwargs):
	session.open(ScriptExecuter)

def mainMENU(session, **kwargs):
	session.open(RebootMENU)

def startMENU(menuid, **kwargs):
	if menuid == "mainmenu":
		if fileExists("/tmp/bootitems.DBA"):
			return [("DuckBA", mainMENU, "duckba", None)]
		else:
			return []
	else:
		return [] 

def Plugins(**kwargs):
	return [PluginDescriptor(name=_("DuckBA manager"), description=_("Manages DuckBA images"), where=PluginDescriptor.WHERE_PLUGINMENU, fnc=main),
	PluginDescriptor(name="DuckBA", where = PluginDescriptor.WHERE_MENU, fnc=startMENU) ]
